// components/header.js
const app = getApp();
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    title:{
      type:String,
      value:'问星数据'
    },
    isBack: {
      type: Boolean,
      value: false
    }
  },
  ready() {
  },
  /**
   * 组件的初始数据
   */
  data: {
    statusNavBarHeight:app.data.statusNavBarHeight,
    safeAreaTop:app.data.safeAreaTop
  },

  /**
   * 组件的方法列表
   */
  methods: {
    back() {
      let pages = getCurrentPages(); //页面对象
      let prevpage = pages[pages.length - 2];
      if(prevpage) {
        swan.navigateBack()
      }else {
        swan.switchTab({
          url: '/pages/index/index'
        })
      }
    }
  }
})
